/*
 * Copyright 2000, International Business Machines Corporation and others.
 * All Rights Reserved.
 * 
 * This software has been released under the terms of the IBM Public
 * License.  For details, see the LICENSE file in the top-level source
 * directory or online at http://www.openafs.org/dl/license10.html
 */

#define IDS_APP_TITLE                   0
#define IDS_USRCOL_NAME                 1 
#define IDS_GRPCOL_NAME                 2 
#define IDS_BADCREDS_DESC               3 
#define IDS_TAB_USERS                   4 
#define IDS_TAB_GROUPS                  5 
#define IDS_CELL_NONE                   6 
#define IDS_CRED_NONE                   7 
#define IDS_CRED_EXP                    8 
#define IDS_CRED_OK                     9 
#define IDS_USERS_ALL                   10
#define IDS_USERS_PATTERN               11
#define IDS_GROUPS_ALL                  12
#define IDS_GROUPS_PATTERN              13
#define IDS_QUERYING_LONG               14
                                        
#define IDS_ACTION_DESC_NONE            16
#define IDS_ACTION_DESC_ONE             17
#define IDS_ACTION_DESC_MULT            18
#define IDS_ACTCOL_OPERATION            19
#define IDS_ACTCOL_ELAPSED              20
#define IDS_ACTION_REFRESH_CELL         21
#define IDS_ACTION_REFRESH_SERVER       22
#define IDS_ACTION_SCOUT_CELL           23
#define IDS_ACTION_SCOUT_SERVER         24
#define IDS_FIND_NOTHING_TITLE          25
#define IDS_FIND_NOTHING_DESC           26
#define IDS_FIND_UNKNOWN_TITLE          27
#define IDS_FIND_UNKNOWN_DESC           28
#define IDS_HELPABOUT_DESC1             29
#define IDS_HELPABOUT_DESC2             30
#define IDS_HELPABOUT_DESC3             31

#define IDS_COLUMNS_TITLE               32
#define IDS_USER_PROPERTIES_TITLE_MULTIPLE 33
#define IDS_USER_PROPERTIES_TITLE       34
#define IDS_USER_NAME_MULTIPLE          35
#define IDS_ACCOUNTACCESS_OWNER         36
#define IDS_ACCOUNTACCESS_GROUP         37
#define IDS_ACCOUNTACCESS_ANYONE        38
#define IDS_ACCOUNTACCESS_MIXED         39
#define IDS_USER_KEY                    40
#define IDS_USER_KEY_HIDDEN             41
#define IDS_USER_KEY_UNKNOWN            42
#define IDS_USER_KEY_MULTIPLE           43
#define IDS_ACTION_USER_CHANGE          44
#define IDS_COUNT_WEEKS                 45
#define IDS_COUNT_DAYS                  46
#define IDS_COUNT_HOURS                 47

#define IDS_COUNT_MINUTES               48
#define IDS_COUNT_SECONDS               49
#define IDS_GROUP_PROPERTIES_TITLE_MULTIPLE 50
#define IDS_GROUP_PROPERTIES_TITLE      51
#define IDS_GROUP_NAME_MULTIPLE         52
#define IDS_ACCOUNTACCESS_OWNGROUP      53
#define IDS_OWNER_MIXED                 54
#define IDS_CREATOR_MIXED               55
#define IDS_GROUP_CHANGEOWNER_TITLE     56
#define IDS_GROUP_CHANGEOWNER_PROMPT    57
#define IDS_MEMBER_MIXED                58
#define IDS_USER_SHOW_MEMBER_TITLE      59
#define IDS_USER_SHOW_OWNER_TITLE       60
#define IDS_GROUP_SHOW_MEMBER_TITLE     61
#define IDS_USER_SHOW_MEMBER_TITLE_MULTIPLE 62
#define IDS_GROUP_SHOW_MEMBER_TITLE_MULTIPLE 63

#define IDS_ACTION_GROUP_RENAME         64
#define IDS_RENAME_TITLE                65
#define IDS_GROUP_TITLE                 66
#define IDS_SHOW_USERS                  67
#define IDS_SHOW_GROUPS                 68
#define IDS_GROUP_SHOW_OWNED_TITLE      69
#define IDS_BROWSE_TITLE_OWNED          70
#define IDS_BROWSE_PROMPT_OWNED         71
#define IDS_BROWSE_CHECK_OWNED          72
#define IDS_NEWUSER_PROPERTIES_TITLE    73
#define IDS_NEWUSER_SHOW_MEMBER_TITLE   74
#define IDS_NEWUSER_SHOW_OWNER_TITLE    75
#define IDS_ACTION_CELL_CHANGE          76
#define IDS_ACTION_USER_CREATE          77
#define IDS_NEWGROUP_PROPERTIES_TITLE   78
#define IDS_NEWGROUP_SHOW_MEMBER_TITLE  79

#define IDS_USRCOL_FLAGS                80
#define IDS_USRCOL_ADMIN                81
#define IDS_USRCOL_TICKET               82
#define IDS_USRCOL_SYSTEM               83
#define IDS_USRCOL_CHANGEPW             84
#define IDS_USRCOL_REUSEPW              85
#define IDS_USRCOL_EXPIRES              86
#define IDS_USRCOL_LASTPW               87
#define IDS_USRCOL_LASTMOD              88
#define IDS_USRCOL_LASTMODBY            89
#define IDS_USRCOL_LIFETIME             90
#define IDS_USRCOL_CDAYPW               91
#define IDS_USRCOL_CFAILLOGIN           92
#define IDS_USRCOL_CSECLOCK             93
#define IDS_USRCOL_CGROUPMAX            94
#define IDS_USRCOL_UID                  95

#define IDS_USRCOL_OWNER                96
#define IDS_USRCOL_CREATOR              97
#define IDS_USRCOL_STATUS               98
#define IDS_USRFLAG_ADMIN               99
#define IDS_USRFLAG_TICKET              100
#define IDS_USRFLAG_ENCRYPT             101
#define IDS_USRFLAG_CHANGEPW            102
#define IDS_USRFLAG_REUSEPW             103
#define IDS_YES                         104
#define IDS_NO                          105
#define IDS_GRPCOL_CMEMBERS             106
#define IDS_GRPCOL_UID                  107
#define IDS_GRPCOL_OWNER                108
#define IDS_GRPCOL_CREATOR              109
#define IDS_COL_USERS                   110
#define IDS_COL_GROUPS                  111

#define IDS_NEWGROUP_SHOW_OWNED_TITLE   112
#define IDS_USER_DELETE_MULTIPLE        113
#define IDS_GROUP_DELETE_MULTIPLE       114
#define IDS_ACTION_GROUP_CREATE         115
#define IDS_ACTION_USER_DELETE          116
#define IDS_ACTION_GROUP_DELETE         117
#define IDS_CELL_PROPERTIES_TITLE       118
#define IDS_MACHINES_ALL                119
#define IDS_MACHINES_PATTERN            120
#define IDS_TAB_MACHINES                121
#define IDS_MACHINE_DELETE_MULTIPLE     122
#define IDS_NEWMACHINE_PROPERTIES_TITLE 123
#define IDS_MACHINE_PROPERTIES_TITLE_MULTIPLE 124
#define IDS_MACHINE_PROPERTIES_TITLE    125
#define IDS_COL_MACHINES                126
#define IDS_MCHCOL_NAME                 127

#define IDS_BROWSE_TITLE_JOIN           128
#define IDS_BROWSE_PROMPT_JOIN          129
#define IDS_BROWSE_CHECK_JOIN           130
#define IDS_BROWSE_TITLE_OWN            131
#define IDS_BROWSE_PROMPT_OWN           132
#define IDS_BROWSE_CHECK_OWN            133
#define IDS_BROWSE_TITLE_MEMBER         134
#define IDS_BROWSE_PROMPT_MEMBER        135
#define IDS_BROWSE_CHECK_MEMBER         136
#define IDS_SEPARATORS                  137
#define IDS_ACTION_GROUP_CHANGE         138
#define IDS_ACTION_GROUP_MEMBER_ADD     139
#define IDS_ACTION_GROUP_MEMBER_REMOVE  140
#define IDS_ACTION_USER_PW_CHANGE       141
#define IDS_UNKNOWN_NAME                142
#define IDS_ACTION_USER_UNLOCK          143

#define IDS_MCHCOL_CGROUPMAX            144
#define IDS_MCHCOL_UID                  145
#define IDS_MCHCOL_OWNER                146
#define IDS_MCHCOL_CREATOR              147
#define IDS_OPTIONS_TITLE               148

#define IDS_COMMAND_PTS_ADDUSER         160
#define IDS_COMMAND_PTS_CHOWN           161
#define IDS_COMMAND_PTS_CREATEGROUP     162
#define IDS_COMMAND_PTS_CREATEUSER      163

#define IDS_COMMAND_PTS_DELETE          176
#define IDS_COMMAND_PTS_EXAMINE         177
#define IDS_COMMAND_PTS_LISTMAX         178
#define IDS_COMMAND_PTS_LISTOWNED       179
#define IDS_COMMAND_PTS_MEMBERSHIP      180
#define IDS_COMMAND_PTS_REMOVEUSER      181
#define IDS_COMMAND_PTS_RENAME          182
#define IDS_COMMAND_PTS_SETFIELDS       183
#define IDS_COMMAND_PTS_SETMAX          184
#define IDS_COMMAND_KAS_CREATE          185
#define IDS_COMMAND_KAS_DELETE          186
#define IDS_COMMAND_KAS_EXAMINE         187
#define IDS_COMMAND_KAS_GETRANDOMKEY    188
#define IDS_COMMAND_KAS_LIST            189
#define IDS_COMMAND_KAS_SETFIELDS       190
#define IDS_COMMAND_KAS_SETKEY          191

#define IDS_COMMAND_KAS_SETPASSWORD     192
#define IDS_COMMAND_KAS_STRINGTOKEY     193
#define IDS_COMMAND_KAS_UNLOCK          194
#define IDS_MACHINE_SHOW_MEMBER_TITLE   195
#define IDS_MACHINE_SHOW_OWNER_TITLE    196
#define IDS_MACHINE_SHOW_MEMBER_TITLE_MULTIPLE 197
#define IDS_NEWMACHINE_SHOW_MEMBER_TITLE 198
#define IDS_NEWMACHINE_SHOW_OWNER_TITLE 199
#define IDS_WARNING_TITLE               200
#define IDS_WARNING_SYSTEM_ACCOUNT      201

#define IDS_ERROR_BAD_REMOTE_SERVER     208
#define IDS_ERROR_BAD_LOCAL_SERVER      209
#define IDS_ERROR_CANT_OPEN_CELL        210
#define IDS_ERROR_BADCREDENTIALS        211

#define IDS_ERROR_TRANSLATED            224
#define IDS_ERROR_NOTTRANSLATED         225
#define IDS_ERROR_USER_MULTIPROP        226
#define IDS_ERROR_CANT_CHANGE_USER      227
#define IDS_ERROR_GROUP_MULTIPROP       228
#define IDS_ERROR_CANT_CHANGE_GROUP     229
#define IDS_ERROR_CANT_TRANSLATE_USER   230
#define IDS_ERROR_CANT_TRANSLATE_GROUP  231
#define IDS_ERROR_CANT_GET_USERPROP     232
#define IDS_ERROR_CANT_CHANGE_PASSWORD  233
#define IDS_ERROR_CANT_GET_RANDOM_KEY   234
#define IDS_ERROR_CANT_SET_GROUPS       235
#define IDS_ERROR_CANT_SET_GROUPS_MULTIPLE 236
#define IDS_ERROR_CANT_UNLOCK           237
#define IDS_ERROR_CANT_UNLOCK_MULTIPLE  238
#define IDS_ERROR_CANT_SET_MEMBERS      239

#define IDS_ERROR_CANT_SET_MEMBERS_MULTIPLE 240
#define IDS_ERROR_CANT_RENAME_GROUP     241
#define IDS_ERROR_CANT_CHANGE_OWNER     242
#define IDS_ERROR_CANT_CHANGE_OWNER_MULTIPLE 243
#define IDS_ERROR_CANT_CHANGE_CELL      244
#define IDS_ERROR_NO_PASSWORD_GIVEN     245
#define IDS_ERROR_MISMATCH_PASSWORD_GIVEN 246
#define IDS_ERROR_CANT_CREATE_USER      247
#define IDS_ERROR_CANT_CREATE_GROUP     248
#define IDS_ERROR_CANT_DELETE_USER      249
#define IDS_ERROR_CANT_DELETE_USER_MULTIPLE 250
#define IDS_ERROR_CANT_DELETE_GROUP     251
#define IDS_ERROR_CANT_DELETE_GROUP_MULTIPLE 252
#define IDS_ERROR_BAD_REMOTE_SERVER_INSTALL 253

#define IDS_CMDLINE_TITLE               256
#define IDS_CMDLINE_SYNTAX              257
#define IDS_CMDLINE_UNRECOGNIZED        258
#define IDS_CMDLINE_DUPLICATE           259
#define IDS_CMDLINE_UNEXPECTVALUE       260
#define IDS_CMDLINE_MISSINGVAL          261
#define IDS_CMDLINE_USERPASSWORD        262



#define IDD_MAIN                        1001
#define ACCEL_MAIN                      1002
#define MENU_MAIN                       1003
#define IDI_MAIN                        1004
#define IDD_TAB_USERS                   1005
#define IDD_TAB_GROUPS                  1006
#define IDD_ACTIONS                     1007
#define IDD_HELP_FIND                   1008
#define IDD_HELP_ERROR                  1009
#define IDD_HELP_ABOUT                  1010
#define MENU_USER_NONE                  1011
#define MENU_GROUP_NONE                 1012
#define MENU_USER                       1013
#define MENU_GROUP                      1014
#define MENU_COLUMNS                    1015
#define IDD_COLUMNS                     1016
#define MENU_MACHINE_NONE               1016
#define IDD_USER_ADVANCED               1017
#define MENU_MACHINE                    1017
#define IDD_USER_GENERAL                1018
#define IDD_GROUP_GENERAL               1019
#define IDD_USER_MEMBER                 1020
#define IDD_GROUP_MEMBER                1021
#define IDD_BROWSE                      1023
#define IDD_BROWSE_JOIN                 1024
#define IDD_BROWSE_OWN                  1025
#define IDD_BROWSE_MEMBER               1026
#define IDD_USER_PASSWORD               1027
#define IDD_GROUP_RENAME                1028
#define IDD_BROWSE_COMBO                1029
#define IDD_BROWSE_OWNER                1030
#define IDD_BROWSE_OWNED                1031
#define IDD_BROWSE_BOTH                 1032
#define IDD_NEWUSER_ACCOUNT             1034
#define IDD_NEWUSER_MEMBER              1035
#define IDD_NEWUSER                     1036
#define IDD_NEWGROUP_GENERAL            1037
#define IDD_NEWGROUP_MEMBER             1038
#define IDD_NEWGROUP                    1039
#define IDD_USER_DELETE                 1040
#define IDD_GROUP_DELETE                1041
#define IDD_CELL_GENERAL                1042
#define IDD_NEWUSER_GENERAL             1043
#define IDD_NEWUSER_ADVANCED            1044
#define IDD_TAB_MACHINES                1045
#define IDD_NEWMACHINE_MEMBER           1046
#define IDD_NEWMACHINE_ADVANCED         1048
#define IDD_NEWMACHINE                  1049
#define IDD_MACHINE_DELETE              1050
#define IDD_MACHINE_ADVANCED            1051
#define IDD_MACHINE_MEMBER              1052
#define IDD_OPTIONS                     1053
#define IDD_SEARCH_USERS                1054
#define IDC_DELETE_KAS                  1165
#define IDC_DELETE_PTS                  1166
#define IDC_TAB                         2000
#define IDC_BAR                         2001
#define IDC_CELL                        2002
#define IDC_CREDS                       2003
#define IDC_ANIM                        2004
#define IDC_USERS_PATTERN               2005
#define IDC_USERS_TITLE                 2006
#define IDC_USERS_LIST                  2007
#define IDC_GROUPS_TITLE                2009
#define IDC_GROUPS_PATTERN              2010
#define IDC_GROUPS_LIST                 2011
#define IDC_USERS_PATTERN_PROMPT        2013
#define IDC_GROUPS_PATTERN_PROMPT       2014
#define IDC_ACTION_DESC                 2015
#define IDC_ACTION_LIST                 2016
#define IDC_FIND_COMMAND                2017
#define IDC_ERROR_NUMBER                2018
#define IDC_ERROR_TRANSLATE             2019
#define IDC_ADVANCED_BOX                2020
#define IDC_HELPABOUT_ICON              2021
#define IDC_HELPABOUT_DESC              2022
#define IDC_COLUMNS                     2023
#define IDC_COL_AVAIL                   2024
#define IDC_COL_INSERT                  2025
#define IDC_COL_DELETE                  2026
#define IDC_COL_SHOWN                   2027
#define IDC_COL_UP                      2028
#define IDC_COL_DOWN                    2029
#define IDC_USER_ADMIN                  2030
#define IDC_BROWSE_CHECK                2030
#define IDC_USER_FAILLOCK               2031
#define IDC_USER_TGS                    2032
#define IDC_USER_CPW                    2033
#define IDC_USER_RPW                    2034
#define IDC_USER_FAILLOCK_DURATION      2035
#define IDC_USER_EXPIRE_TIME            2036
#define IDC_USER_EXPIRES                2037
#define IDC_USER_NOSEAL                 2038
#define IDC_USER_FAILLOCK_COUNT         2040
#define IDC_USER_PERM_STATUS            2042
#define IDC_USER_CPW_NOW                2045
#define IDC_USER_FAILLOCK_INFINITE      2047
#define IDC_USER_LIFETIME               2048
#define IDC_USER_PWEXPIRES              2050
#define IDC_USER_PWEXPIRATION           2051
#define IDC_USER_PERM_OWNED             2052
#define IDC_USER_PERM_MEMBER            2053
#define IDC_USER_NAME                   2055
#define IDC_USER_EXPIRE_DATE            2056
#define IDC_USER_GROUP_QUOTA            2057
#define IDC_USER_KEY                    2058
#define IDC_USER_EXPIRE_AT              2059
#define IDC_GROUP_NAME                  2060
#define IDC_GROUP_PERM_STATUS           2061
#define IDC_GROUP_PERM_GROUPS           2062
#define IDC_GROUP_PERM_MEMBERS          2063
#define IDC_GROUP_PERM_ADD              2064
#define IDC_GROUP_PERM_REMOVE           2065
#define IDC_GROUP_OWNER                 2066
#define IDC_GROUP_CHANGEOWNER           2067
#define IDC_GROUP_CREATOR               2068
#define IDC_USER_SHOW_MEMBER            2068
#define IDC_USER_SHOW_OWNER             2069
#define IDC_MEMBER_REMOVE               2070
#define IDC_MEMBER_ADD                  2071
#define IDC_CPW_VERSION_AUTO            2074
#define IDC_CPW_VERSION_MANUAL          2075
#define IDC_CPW_TITLE                   2076
#define IDC_CPW_VERSION                 2077
#define IDC_CPW_STRING                  2078
#define IDC_CPW_BYSTRING                2079
#define IDC_CPW_DATA                    2080
#define IDC_CPW_BYDATA                  2081
#define IDC_CPW_RANDOM                  2082
#define IDC_RENAME_OLDNAME              2083
#define IDC_RENAME_NEWNAME              2084
#define IDC_RENAME_OWNER                2085
#define IDC_RENAME_CHOWN                2086
#define IDC_RENAME_TITLE                2087
#define IDC_BROWSE_COMBO                2088
#define IDC_GROUP_SHOW_MEMBER           2089
#define IDC_GROUP_SHOW_OWNER            2090
#define IDC_NEWUSER_TITLE               2092
#define IDC_NEWUSER_NAME                2093
#define IDC_NEWUSER_ID_AUTO             2094
#define IDC_NEWUSER_ID_MANUAL           2095
#define IDC_NEWUSER_ID                  2096
#define IDC_NEWUSER_PW1                 2097
#define IDC_NEWUSER_PW2                 2098
#define IDC_ADVANCED                    2099
#define IDC_USER_CREATE_KAS             2100
#define IDC_USER_CREATE_PTS             2101
#define IDC_NEWGROUP_NAME               2101
#define IDC_NEWGROUP_TITLE              2102
#define IDC_NEWGROUP_ID_AUTO            2103
#define IDC_NEWGROUP_ID_MANUAL          2104
#define IDC_NEWGROUP_ID                 2105
#define IDC_DELETE_TITLE                2106
#define IDC_BROWSE_PATTERN              2107
#define IDC_CELL_NAME                   2108
#define IDC_CELL_USERMAX                2109
#define IDC_CELL_GROUPMAX               2110
#define IDC_MACHINES_LIST               2113
#define IDC_MACHINES_TITLE              2114
#define IDC_MACHINES_PATTERN            2115
#define IDC_MACHINES_PATTERN_PROMPT     2116
#define IDC_USER_GROUP_HASQUOTA         2117
#define IDC_USER_GROUP_NOQUOTA          2118
#define IDC_USER_FAILLOCK_FINITE        2119
#define IDC_USER_GROUP_HASQUOTA2        2119
#define IDC_USER_UNLOCK                 2120
#define IDC_REGEXP_UNIX                 2123
#define IDC_REGEXP_WINDOWS              2124
#define IDC_WARN_BADCREDS               2125
#define IDC_REFRESH                     2126
#define IDC_REFRESH_RATE                2127
#define IDC_SEARCH_ALL                  2130
#define IDC_SEARCH_EXPIRE               2131
#define IDC_SEARCH_PWEXPIRE             2132
#define IDC_SEARCH_EXPIRE_DATE          2133
#define IDC_SEARCH_PWEXPIRE_DATE        2134
#define M_OPENCELL                      3001
#define M_CREDENTIALS                   3002
#define M_EXIT                          3003
#define M_KEY_RETURN                    3004
#define M_KEY_TAB                       3005
#define M_KEY_BACKTAB                   3006
#define M_KEY_MENU                      3007
#define M_KEY_ESC                       3008
#define M_KEY_CTRLTAB                   3009
#define M_KEY_CTRLBACKTAB               3010
#define M_KEY_PROPERTIES                3011
#define M_CONTENTS                      3012
#define M_FIND                          3013
#define M_LOOKUP                        3014
#define M_ABOUT                         3015
#define M_VIEW_LARGE                    3016
#define M_VIEW_SMALL                    3017
#define M_VIEW_DETAILS                  3018
#define M_VIEW_ONE                      3019
#define M_VIEW_TWO                      3020
#define M_VIEW_STATUS                   3021
#define M_ACTIONS                       3022
#define M_OPTIONS                       3023
#define M_REFRESHALL                    3024
#define M_CELL_PROPERTIES               3025
#define M_USER_CREATE                   3026
#define M_GROUP_CREATE                  3027
#define M_UNLOCK                        3029
#define M_MEMBERSHIP                    3030
#define M_REFRESH                       3031
#define M_PROPERTIES                    3032
#define M_SELECTALL                     3033
#define M_RENAME                        3034
#define M_DELETE                        3035
#define M_COLUMNS                       3036
#define M_CPW                           3037
#define M_MACHINE_CREATE                3038
#define IDC_STATIC                      -1

// Next default values for new objects
// 
#ifdef APSTUDIO_INVOKED
#ifndef APSTUDIO_READONLY_SYMBOLS
#define _APS_NO_MFC                     1
#define _APS_NEXT_RESOURCE_VALUE        1032
#define _APS_NEXT_COMMAND_VALUE         3036
#define _APS_NEXT_CONTROL_VALUE         2136
#define _APS_NEXT_SYMED_VALUE           101
#endif
#endif
